//+------------------------------------------------------------------+
//| Close All Activ Orders.mq4                                      |
//| SwingMan, 2010.03.10                                             |
//+------------------------------------------------------------------+
#property copyright "SwingMan, 2010.03.10"
#property link ""
#property show_confirm

//+------------------------------------------------------------------+
//| script program start function |
//+------------------------------------------------------------------+
int i,total,err;
int iOrderTicket[20];
int nActivOrders;

//____________________________________________________________________
int start()
{
   Get_ActivOrders();

   if (nActivOrders > 0)
   {
      Close_AllActivOrder();
   }
   return(0);
}
//+------------------------------------------------------------------+


//____________________________________________________________________
void Get_ActivOrders()
{
   total = OrdersTotal();
   nActivOrders = 0;
   for (int i=0; i <=total; i++)
   {
      if(OrderSelect(i,SELECT_BY_POS, MODE_TRADES))
      {
         if (OrderSymbol() == Symbol() && OrderCloseTime() == 0)
            if (OrderType()==OP_BUY || OrderType()==OP_SELL)
            {
               nActivOrders++;
               iOrderTicket[nActivOrders] = OrderTicket();
            }         
      }      
   }
}

//____________________________________________________________________
void Close_AllActivOrder()
{
   for (int i=1; i<=nActivOrders; i++)
   {
      int iTicket = iOrderTicket[i];
      if(OrderSelect(iTicket,SELECT_BY_TICKET))
      {
         if(OrderType()==OP_BUY)
         {
            OrderClose(iTicket,OrderLots(),Bid,10,Blue);
            err=GetLastError();
            while(err==129)
            {
               RefreshRates();
               //Sleep(100);
               OrderClose(iTicket,OrderLots(),Bid,10,Blue);
               err=GetLastError();
            }
            Print("Buy Error: ",err);
         }
         if(OrderType()==OP_SELL)
         {
            OrderClose(iTicket,OrderLots(),Ask,10,Red);
            err=GetLastError();
            while(err==129)
            {
               RefreshRates();
               //Sleep(100);
               OrderClose(OrderTicket(),OrderLots(),Ask,10,Blue);
               err=GetLastError();
            } 
            Print("Sell Error: ",err);
         }
      }
   }   
}

